diff --git a/tests/Feature/FunctionalTestCase.php b/tests/Feature/FunctionalTestCase.php
new file mode 100644
index 0000000..21d4a31
--- /dev/null
+++ b/tests/Feature/FunctionalTestCase.php
@@ -0,0 +1,168 @@
+<?php
+
+namespace Tests\Feature;
+
+use DB;
+use Schema;
+use Settings;
+use Tests\TestCase;
+use Portal\Role;
+use Portal\User;
+use Mockery as m;
+
+class FunctionalTestCase extends TestCase
+{
+    use \Illuminate\Foundation\Testing\Concerns\InteractsWithDatabase;
+
+    protected $seed = true;
+
+    protected $settingsModified = [];
+
+    public function setUp()
+    {
+        $this->afterApplicationCreated(function () {
+            if ($this->isSQLiteConnection()) {
+                DB::connection()->getPdo()->exec("pragma foreign_keys=1");
+            }
+
+            $this->artisan('migrate');
+
+            if ($this->seed) {
+                $this->artisan('db:seed', ['--class' => 'CountriesSeeder']);
+                $this->artisan('db:seed', ['--class' => 'RolesSeeder']);
+                $this->artisan('db:seed', ['--class' => 'PermissionsSeeder']);
+            }
+        });
+
+        $this->beforeApplicationDestroyed(function () {
+            if (Schema::hasTable('migrations')) {
+                $this->artisan('migrate:rollback');
+            }
+            \DB::disconnect();
+        });
+
+        $this->beforeApplicationDestroyed(function () {
+            foreach ($this->settingsModified as $key => $value) {
+                Settings::set($key, $value);
+            }
+
+            Settings::save();
+
+            $this->settingsModified = [];
+        });
+
+        parent::setUp();
+    }
+
+    /**
+     * Set some setting that should automatically be
+     * reverted to it's default value after each test.
+     * @param array $settings
+     */
+    protected function setSettings(array $settings)
+    {
+        foreach ($settings as $key => $value) {
+            $this->settingsModified[$key] = settings($key);
+            Settings::set($key, $value);
+        }
+
+        Settings::save();
+
+        $this->refreshAppAndExecuteCallbacks();
+    }
+
+    /**
+     * @param array $attrubutes
+     * @return mixed
+     */
+    protected function createAndLoginUser(array $attrubutes = [])
+    {
+        $user = $this->createUserWithSocialNetworks($attrubutes);
+
+        $user = $this->setRoleForUser($user, 'User');
+
+        $this->be($user);
+
+        return $user;
+    }
+
+    /**
+     * @param array $attrubutes
+     * @return mixed
+     */
+    protected function createAndLoginAdminUser(array $attrubutes = [])
+    {
+        $user = $this->createUserWithSocialNetworks($attrubutes);
+
+        $user = $this->setRoleForUser($user, 'Admin');
+
+        $this->be($user);
+
+        return $user;
+    }
+
+    /**
+     * @param array $attributes
+     * @return mixed
+     */
+    protected function createUserWithSocialNetworks(array $attributes = [])
+    {
+        $user = factory(User::class)->create($attributes);
+        $user->socialNetworks()->create([]);
+
+        return $user;
+    }
+
+    /**
+     * @return mixed
+     */
+    protected function createSuperUser()
+    {
+        $user = factory(User::class)->create();
+        return $this->makeSuperUser($user);
+    }
+
+    protected function makeSuperUser(User $user = null)
+    {
+        $user = m::mock($user ?: User::class)->makePartial();
+        $user->shouldReceive('can')->andReturn(true);
+
+        return $user;
+    }
+
+    /**
+     * @param User $user
+     * @param $role
+     * @return User
+     */
+    public function setRoleForUser(User $user, $role)
+    {
+        $role = Role::where('name', $role)->first();
+        $user->roles()->attach($role);
+
+        return $user;
+    }
+
+    public function seeInTable($selector, $text, $rowNumber, $columnNumber, $negate = false)
+    {
+        $fullSelector = "{$selector} tbody tr:nth-child({$rowNumber}) > td:nth-child({$columnNumber})";
+        return $this->seeInElement($fullSelector, $text, $negate);
+    }
+
+    public function dontSeeInTable($selector, $text, $rowNumber, $columnNumber)
+    {
+        return $this->seeInTable($selector, $text, $rowNumber, $columnNumber, true);
+    }
+
+    /**
+     * Click on link that matches provided selector.
+     *
+     * @param $selector
+     * @return $this
+     */
+    protected function clickOn($selector)
+    {
+        $link = $this->crawler->filter($selector)->first();
+        return $this->visit($link->link()->getUri());
+    }
+}
diff --git a/tests/Feature/Http/Controllers/ActivityControllerTest.php b/tests/Feature/Http/Controllers/ActivityControllerTest.php
new file mode 100644
index 0000000..27b1e95
--- /dev/null
+++ b/tests/Feature/Http/Controllers/ActivityControllerTest.php
@@ -0,0 +1,84 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers;
+
+use Input;
+use Tests\Feature\FunctionalTestCase;
+use Portal\User;
+use Carbon\Carbon;
+
+class ActivityControllerTest extends FunctionalTestCase
+{
+    /**
+     * @var \Portal\Services\Logging\UserActivity\Logger
+     */
+    public $logger;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->logger = app(\Portal\Services\Logging\UserActivity\Logger::class);
+    }
+
+    public function test_display_all_activities()
+    {
+        $this->withoutMiddleware();
+
+        $user1 = factory(User::class)->create();
+        $user2 = factory(User::class)->create();
+
+        Carbon::setTestNow(Carbon::now());
+        $this->be($user1);
+        $this->logger->log('foo');
+
+        $this->be($user2);
+        $this->logger->log('bar');
+
+        $this->visit('activity');
+
+        $this->assertEquals(2, $this->crawler->filter('table tbody tr')->count());
+
+        $this->seeUserActivity($user1, 'foo', 1);
+        $this->seeUserActivity($user2, 'bar', 2);
+    }
+
+    public function test_display_activities_for_user()
+    {
+        $user = $this->createAndLoginAdminUser();
+
+        $this->logger->log('foo');
+
+        $this->visit('activity')
+            ->clickOn('table tbody a:first-child')
+            ->seePageIs("activity/user/{$user->id}/log")
+            ->seeUserActivity($user, 'foo', 1);
+    }
+
+    public function test_search_activities()
+    {
+        $this->withoutMiddleware();
+
+        $user = factory(User::class)->create();
+        $this->be($user);
+        $this->logger->log('foo');
+        $this->logger->log('bar');
+
+        $this->visit('activity')
+            ->type('fo', 'search')
+            ->press('search-activities-btn');
+
+        $this->seePageIs('activity?search=fo');
+        $this->assertEquals(1, $this->crawler->filter('table tbody tr')->count());
+        $this->seeUserActivity($user, 'foo', 1);
+    }
+
+    private function seeUserActivity($user, $message, $row)
+    {
+        return $this->seeInTable('table', $user->present()->nameOrEmail, $row, 1)
+            ->seeInTable('table', Input::ip(), $row, 2)
+            ->seeInTable('table', $message, $row, 3)
+            ->seeInTable('table', Carbon::now(), $row, 4)
+            ->seeElement("table tbody tr:nth-child({$row}) > td:nth-child(5) > a[data-content='".Input::header('User-agent')."']");
+    }
+
+}
diff --git a/tests/Feature/Http/Controllers/Auth/AuthControllerTest.php b/tests/Feature/Http/Controllers/Auth/AuthControllerTest.php
new file mode 100644
index 0000000..e676f84
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Auth/AuthControllerTest.php
@@ -0,0 +1,399 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Auth;
+
+use Authy;
+use Mockery;
+use Settings;
+use Tests\Feature\FunctionalTestCase;
+use Tests\MailTrap;
+use Portal\Events\User\LoggedIn;
+use Portal\Events\User\Registered;
+use Portal\Role;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+use Mockery as m;
+
+class AuthControllerTest extends FunctionalTestCase
+{
+    use MailTrap;
+
+    public function test_login()
+    {
+        factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
+
+        $this->loginUser('foo', 'bar')
+            ->seePageIs('/');
+    }
+
+    public function test_login_with_wrong_credentials()
+    {
+        $this->loginUser('foo', 'bar')
+            ->seePageIs('login')
+            ->see("These credentials do not match our records.");
+    }
+
+    public function test_throttling()
+    {
+        $this->setSettings([
+            'throttle_enabled' => true,
+            'throttle_attempts' => 3,
+            'throttle_lockout_time' => 2 // 2 minutes
+        ]);
+
+        for ($i = 0; $i < 3; $i++) {
+            $this->loginUser('foo', 'bar');
+        }
+
+        $this->loginUser('foo', 'bar')
+            ->seePageIs('login')
+            ->see("Too many login attempts. Please try again in 120 seconds.");
+    }
+
+    public function test_login_with_remember()
+    {
+        $user = factory(User::class)->create([
+            'username' => 'foo',
+            'password' => 'bar',
+            'last_login' => null,
+            'remember_token' => null
+        ]);
+
+        Settings::set('remember_me', false);
+
+        $this->visit('login')
+            ->dontSeeElement('#remember');
+
+        Settings::set('remember_me', true);
+
+        $this->visit('login')
+            ->seeElement('#remember')
+            ->loginUser('foo', 'bar', true)
+            ->seePageIs('/');
+
+        $user = $user->fresh();
+
+        $this->assertNotNull($user->remember_token);
+        $this->assertNotNull($user->last_login);
+    }
+
+    public function test_banned_user_cannot_log_in()
+    {
+        factory(User::class)->create([
+            'username' => 'foo',
+            'password' => 'bar',
+            'status' => UserStatus::BANNED
+        ]);
+
+        $this->loginUser('foo', 'bar');
+
+        $this->seePageIs('login')
+            ->see("Your account is banned by administrator.");
+    }
+
+    public function test_unconfirmed_user_cannot_login()
+    {
+        factory(User::class)->create([
+            'username' => 'foo',
+            'password' => 'bar',
+            'status' => UserStatus::UNCONFIRMED
+        ]);
+
+        $this->loginUser('foo', 'bar');
+
+        $this->seePageIs('login')
+            ->see("Please confirm your email address first.");
+    }
+
+    /**
+     * @expectedException \Laravel\BrowserKitTesting\HttpException
+     */
+    public function test_registration_view()
+    {
+        $this->setSettings([
+            'reg_enabled' => false
+        ]);
+
+        $this->visit('login')
+            ->dontSee('You don\'t have an account?');
+
+        // This should fire HttpException since registration is disabled.
+        $this->visit('register');
+    }
+
+    public function test_registration_with_email_confirmation()
+    {
+        $this->setSettings([
+            'reg_enabled' => true,
+            'reg_email_confirmation' => true,
+            'registration.captcha.enabled' => false
+        ]);
+
+        $this->expectsEvents(Registered::class);
+
+        $data = $this->getRegistrationFormStubData();
+
+        $this->registerUser($data);
+
+        $expected = array_except($data, ['password', 'password_confirmation', 'tos']);
+        $expected += ['status' => UserStatus::UNCONFIRMED];
+
+        $this->seePageIs('login')
+            ->see('You account is created successfully! Please confirm your email in order to log in.')
+            ->seeInDatabase('users', $expected);
+
+        $token = User::where('email', $data['email'])->first()->confirmation_token;
+
+        $message = $this->fetchInbox()[0];
+
+        $this->assertEquals('test@test.com', $message['to_email']);
+        $this->assertEquals(config('mail.from.address'), $message['from_email']);
+        $this->assertEquals(config('mail.from.name'), $message['from_name']);
+        $this->assertContains(
+            trans('app.thank_you_for_registering', ['app' => settings('app_name')]),
+            trim($message['html_body'])
+        );
+        $this->assertContains(
+            trans('app.confirm_email_on_link_below'),
+            trim($message['html_body'])
+        );
+        $this->assertContains(
+            route('register.confirm-email', $token),
+            trim($message['html_body'])
+        );
+
+        $this->emptyInbox();
+    }
+
+    public function test_registration_without_email_confirmation()
+    {
+        $this->setSettings([
+            'reg_enabled' => true,
+            'reg_email_confirmation' => false,
+            'notifications_signup_email' => false,
+            'registration.captcha.enabled' => false
+        ]);
+
+        $this->expectsEvents(Registered::class);
+
+        $data = $this->getRegistrationFormStubData();
+        $this->registerUser($data);
+
+        $expected = array_except($data, ['password', 'password_confirmation', 'tos']);
+        $expected += ['status' => UserStatus::ACTIVE];
+
+        $this->seePageIs('login')
+            ->see('You account is created successfully! You can log in now.')
+            ->seeInDatabase('users', $expected);
+
+        $this->assertEmpty($this->fetchInbox());
+    }
+
+    public function test_email_notification_when_new_user_was_registered()
+    {
+        $this->setSettings([
+            'app_name' => 'foo',
+            'reg_enabled' => true,
+            'reg_email_confirmation' => false,
+            'notifications_signup_email' => true,
+            'registration.captcha.enabled' => false
+        ]);
+
+        $admin1 = factory(User::class)->create(['email' => 'john.doe@test.com']);
+        $admin2 = factory(User::class)->create(['email' => 'jane.doe@test.com']);
+        $user = factory(User::class)->create(['email' => 'user.doe@test.com']);
+
+        $role = Role::where('name', 'Admin')->first();
+        $role->users()->attach([$admin1->id, $admin2->id]);
+
+        $role = Role::where('name', 'User')->first();
+        $role->users()->attach($user->id);
+
+        $data = $this->getRegistrationFormStubData();
+        $this->registerUser($data);
+
+        $newUser = User::where('email', $data['email'])->first();
+
+        $inbox = $this->fetchInbox();
+
+        $this->assertEquals(2, count($inbox));
+
+        $this->assertEquals('[foo] New User Registration', $inbox[0]['subject']);
+        $this->assertEquals('jane.doe@test.com', $inbox[0]['to_email']);
+        $this->assertContains(
+            trans('app.new_user_was_registered_on', ['app' => settings('app_name')]),
+            trim($inbox[0]['html_body'])
+        );
+        $this->assertContains(
+            trans('app.to_view_details_visit_link_below'),
+            trim($inbox[0]['html_body'])
+        );
+        $this->assertContains(
+            route('user.show', $newUser->id),
+            trim($inbox[0]['html_body'])
+        );
+
+        $this->assertEquals('[foo] New User Registration', $inbox[1]['subject']);
+        $this->assertEquals('john.doe@test.com', $inbox[1]['to_email']);
+
+        $this->emptyInbox();
+    }
+
+    public function test_redirect_to_custom_page_after_login()
+    {
+        $to = '?to=http://www.google.com';
+
+        factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
+
+        $this->visit('login' . $to)
+            ->seeElement('input', ['type' => 'hidden', 'name' => 'to'])
+            ->type('foo', 'username')
+            ->type('bar', 'password')
+            ->press('Log In');
+
+        $this->seePageIs('http://www.google.com');
+    }
+
+    public function test_custom_redirect_page_is_available_after_failed_login_attempt()
+    {
+        $to = 'http://www.google.com';
+        $element = 'input';
+        $elementAttrs = ['type' => 'hidden', 'name' => 'to'];
+
+        $this->visit('login?to=' . $to)
+            ->seeElement($element, $elementAttrs)
+            ->type('foo', 'username')
+            ->type('bar', 'password')
+            ->press('Log In');
+
+        $this->seePageIs('login?to=' . urlencode($to))
+            ->seeElement($element, $elementAttrs);
+    }
+
+    public function test_access_to_auth_pages_is_not_allowed_after_authentication()
+    {
+        $this->setSettings([
+            'reg_enabled' => true,
+            '2fa.enabled' => true
+        ]);
+
+        $this->refreshAppAndExecuteCallbacks();
+
+        factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
+        $this->loginUser('foo', 'bar');
+
+        $forbiddenGetRoutes = [
+            'login', 'register', 'register/confirmation/123', 'password/remind', 'password/reset/123',
+            'auth/two-factor-authentication', 'auth/facebook/login', 'auth/facebook/callback',
+            'auth/twitter/email'
+        ];
+
+        foreach ($forbiddenGetRoutes as $route) {
+            $this->visit($route)
+                ->seePageIs('/');
+        }
+    }
+
+    private function getRegistrationFormStubData()
+    {
+        return [
+            'email' => 'test@test.com',
+            'username' => 'johndoe',
+            'password' => '123123',
+            'password_confirmation' => '123123',
+            'tos' => 1
+        ];
+    }
+
+    private function registerUser($data)
+    {
+        return $this->visit('login')
+            ->click("Don't have an account?")
+            ->seePageIs('register')
+            ->submitForm('Register', $data);
+    }
+
+    /**
+     * @param $username
+     * @param $password
+     * @param bool $remember
+     * @return $this
+     */
+    private function loginUser($username, $password, $remember = false)
+    {
+        $this->visit('login')
+            ->type($username, 'username')
+            ->type($password, 'password');
+
+        if ($remember) {
+            $this->check('remember');
+        }
+
+        $this->press('Log In');
+
+        return $this;
+    }
+
+    public function test_login_with_2fa_enabled()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->expectsEvents(LoggedIn::class);
+
+        $user = factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('tokenIsValid')->with(m::any(), '123')->andReturn(true);
+
+        $this->loginUser('foo', 'bar')
+            ->seePageIs('auth/two-factor-authentication')
+            ->seeInSession('auth.2fa.id', $user->id);
+
+        $this->type('123', 'token')
+            ->press('Validate')
+            ->seePageIs('/');
+    }
+
+    public function test_login_with_wrong_2fa_token()
+    {
+        $this->setSettings(['2fa.enabled' => true]);
+
+        $this->refreshAppAndExecuteCallbacks();
+
+        $user = factory(User::class)->create(['username' => 'foo', 'password' => 'bar']);
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('tokenIsValid')->with(m::any(), '123')->andReturn(false);
+
+        $this->loginUser('foo', 'bar')
+            ->seePageIs('auth/two-factor-authentication')
+            ->seeInSession('auth.2fa.id', $user->id);
+
+        $this->type('123', 'token')
+            ->press('Validate')
+            ->seePageIs('login')
+            ->see('2FA Token is invalid!');
+    }
+
+    /**
+     * Mock the event dispatcher so all events are silenced and collected.
+     * We will override it to allow model events though, since we want
+     * user notifications to be sent, so we can test them.
+     *
+     * @return $this
+     */
+    protected function withoutEvents()
+    {
+        $mock = Mockery::mock('Illuminate\Contracts\Events\Dispatcher');
+
+        $mock->shouldReceive('fire', 'dispatch')->andReturnUsing(function ($called) {
+            $this->firedEvents[] = $called;
+        });
+
+        $mock->shouldReceive('until');
+
+        $this->app->instance('events', $mock);
+
+        return $this;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Auth/PasswordControllerTest.php b/tests/Feature/Http/Controllers/Auth/PasswordControllerTest.php
new file mode 100644
index 0000000..02ed9b1
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Auth/PasswordControllerTest.php
@@ -0,0 +1,167 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Authy;
+
+use DB;
+use Hash;
+use Illuminate\Support\Str;
+use Mockery;
+use Tests\Feature\FunctionalTestCase;
+use Tests\MailTrap;
+use Portal\Events\User\RequestedPasswordResetEmail;
+use Portal\User;
+use Mockery as m;
+
+class PasswordControllerTest extends FunctionalTestCase
+{
+    use MailTrap;
+
+    public function test_send_password_reminder()
+    {
+        factory(User::class)->create(['email' => 'test@test.com']);
+
+        $this->expectsEvents(RequestedPasswordResetEmail::class);
+
+        $this->visit('password/remind')
+            ->type('test@test.com', 'email')
+            ->press('Reset Password')
+            ->seePageIs('password/remind')
+            ->see('Password reset email sent. Check your inbox (and spam) folder.');
+
+        $message = $this->fetchInbox()[0];
+
+        $this->assertEquals('test@test.com', $message['to_email']);
+        $this->assertEquals(config('mail.from.address'), $message['from_email']);
+        $this->assertEquals(config('mail.from.name'), $message['from_name']);
+        $this->assertContains(
+            trans('app.request_for_password_reset_made'),
+            $message['html_body']
+        );
+
+        $this->assertContains(
+            trans('app.if_you_did_not_requested'),
+            $message['html_body']
+        );
+
+        $this->emptyInbox();
+    }
+
+    public function test_password_reminder_with_wrong_email()
+    {
+        $this->visit('password/remind')
+            ->type('test@test.com', 'email')
+            ->press('Reset Password')
+            ->seePageIs('password/remind')
+            ->see('The selected email is invalid.');
+    }
+
+    public function test_password_reset()
+    {
+        $this->setSettings(['forgot_password' => true]);
+
+        $user = factory(User::class)->create(['email' => 'test@test.com']);
+
+        $token = $this->createNewToken();
+
+        DB::table('password_resets')->insert([
+            'email' => $user->email,
+            'token' => Hash::make($token),
+            'created_at' => \Carbon\Carbon::now()
+        ]);
+
+        $this->resetPassword($token, $user->email);
+
+        $this->seePageIs('login')
+            ->see('Your password has been reset!');
+
+        $user = $user->fresh();
+
+        $this->assertTrue(Hash::check('123123', $user->password));
+    }
+
+    public function test_password_reset_with_expired_token()
+    {
+        $this->setSettings(['forgot_password' => true]);
+
+        $user = factory(User::class)->create(['email' => 'test@test.com']);
+
+        $token = $this->createNewToken();
+
+        DB::table('password_resets')->insert([
+            'email' => $user->email,
+            'token' => Hash::make($token),
+            'created_at' => \Carbon\Carbon::now()->subHours(2)
+        ]);
+
+        $this->resetPassword($token, $user->email);
+
+        $this->seePageIs("password/reset/{$token}")
+            ->see("This password reset token is invalid.");
+    }
+
+    public function test_password_reset_with_invalid_email()
+    {
+        $this->setSettings(['forgot_password' => true]);
+
+        $user = factory(User::class)->create(['email' => 'test@test.com']);
+
+        $token = $this->createNewToken();
+
+        DB::table('password_resets')->insert([
+            'email' => $user->email,
+            'token' => Hash::make($token),
+            'created_at' => \Carbon\Carbon::now()
+        ]);
+
+        $this->resetPassword($token, 'foo@bar.com');
+
+        $this->seePageIs("password/reset/{$token}")
+            ->see("We can't find a user with that e-mail address.");
+    }
+
+    /**
+     * @param $token
+     * @param $email
+     */
+    private function resetPassword($token, $email)
+    {
+        $this->visit("password/reset/{$token}")
+            ->type($email, 'email')
+            ->type('123123', 'password')
+            ->type('123123', 'password_confirmation')
+            ->press('Update Password');
+    }
+
+    /**
+     * Mock the event dispatcher so all events are silenced and collected.
+     * We will override it to allow model events though, since we want
+     * user notifications to be sent, so we can test them.
+     *
+     * @return $this
+     */
+    protected function withoutEvents()
+    {
+        $mock = Mockery::mock('Illuminate\Contracts\Events\Dispatcher');
+
+        $mock->shouldReceive('fire', 'dispatch', 'getCommandHandler')->andReturnUsing(function ($called) {
+            $this->firedEvents[] = $called;
+        });
+
+        $mock->shouldReceive('until');
+
+        $this->app->instance('events', $mock);
+
+        return $this;
+    }
+
+    private function createNewToken()
+    {
+        $key = $this->app['config']['app.key'];
+
+        if (Str::startsWith($key, 'base64:')) {
+            $key = base64_decode(substr($key, 7));
+        }
+
+        return hash_hmac('sha256', Str::random(40), $key);
+    }
+}
